﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        List<int> usedCards = new List<int>();
        List<int> usedACards = new List<int>();
        bool player1draw = true, player2draw = true, player = true;
        int counter = 0, initalCount = 0, player1card = 0, player2card = 0, player1score = 0, player2score = 0, card = 0, score1 = 0, score2 = 0;
        int[] cats = new int[10];
        int[] audienceValues = new int[4];
       
        
        public Form1()
        {
            InitializeComponent();
            Hidden1.ImageLocation = "Images\\Hidden.bmp";
            Hidden1.SizeMode = PictureBoxSizeMode.Zoom;
            Hidden2.ImageLocation = "Images\\Hidden.bmp";
            Hidden2.SizeMode = PictureBoxSizeMode.Zoom;
            Player1();
            Player2();
            Audience();
            initalCount = 0;
       }

        public void Player1()
        {
            if (player1draw)
            {
                Card1.ImageLocation = hand_draw();
                Card1.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                Card2.ImageLocation = hand_draw();
                Card2.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                Card3.ImageLocation = hand_draw();
                Card3.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                Card4.ImageLocation = hand_draw();
                Card4.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                Card5.ImageLocation = hand_draw();
                Card5.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                player1draw = false;
            }
        }

        public void Player2()
        {
            if (player2draw)
            {
                Card6.ImageLocation = hand_draw();
                Card6.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                Card7.ImageLocation = hand_draw();
                Card7.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                Card8.ImageLocation = hand_draw();
                Card8.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                Card9.ImageLocation = hand_draw();
                Card9.SizeMode = PictureBoxSizeMode.Zoom;
                initalCount++;
                Card10.ImageLocation = hand_draw();
                Card10.SizeMode = PictureBoxSizeMode.Zoom;
                player2draw = false;
            }
        }

        public void Audience()
        {
            initalCount = 0;
            aCard1.ImageLocation = audience_draw();
            aCard1.SizeMode = PictureBoxSizeMode.Zoom;
            initalCount++;
            aCard2.ImageLocation = audience_draw();
            aCard2.SizeMode = PictureBoxSizeMode.Zoom;
            initalCount++;
            aCard3.ImageLocation = audience_draw();
            aCard3.SizeMode = PictureBoxSizeMode.Zoom;
            initalCount++;
            aCard4.ImageLocation = audience_draw();
            aCard4.SizeMode = PictureBoxSizeMode.Zoom;
            initalCount = 0;
        }

        public void AudienceThingy()
        {
            aCard1.ImageLocation = "Images\\a" + Convert.ToString(audienceValues[2]) + ".bmp";
            aCard1.SizeMode = PictureBoxSizeMode.Zoom;
            audienceValues[0] = audienceValues[2];
            aCard2.ImageLocation = "Images\\a" + Convert.ToString(audienceValues[3]) + ".bmp";
            aCard2.SizeMode = PictureBoxSizeMode.Zoom;
            audienceValues[1] = audienceValues[3];
            initalCount = 2;
            aCard3.ImageLocation = audience_draw();
            aCard3.SizeMode = PictureBoxSizeMode.Zoom;
            initalCount++;
            aCard4.ImageLocation = audience_draw();
            aCard4.SizeMode = PictureBoxSizeMode.Zoom;
        }

        public string audience_draw()
        {
            string cardfilepath = "";
            bool loop = true;
            while (loop)
            {
                Random rnd = new Random();
                int cardnum = rnd.Next(1, 41);
                if (!usedACards.Contains(cardnum))
                {
                    usedACards.Add(cardnum);
                    label4.Text = "Audience Cards Remaining: " + (40 - usedACards.Count);
                    cardfilepath = "Images\\a" + Convert.ToString(cardnum) + ".bmp";
                    if (initalCount < 4)
                        audienceValues[initalCount] = cardnum;
                    loop = false;
                } 
            }
            return cardfilepath;
        }

        public string hand_draw()
        {
            string cardfilepath = "";
            bool loop = true;
            
            card = cats[initalCount];
            while (loop)
            {
                Random rnd = new Random();
                int cardnum = rnd.Next(1, 61);
                    if (!usedCards.Contains(cardnum))
                    {
                        usedCards.Add(cardnum);
                        label3.Text = "Cards Remaining: " + (60 - usedCards.Count);
                        cardfilepath = "Images\\" + Convert.ToString(cardnum) + ".bmp";
                        if (initalCount < 11)
                            cats[initalCount] = catagories(cardnum);
                        
                        loop = false;
                    }
            }
            return cardfilepath;
        }

        private void Card1_Click(object sender, EventArgs e)
        {
            if (player)
            {
                initalCount = 0;
                Player1choice.Image = Card1.Image;
                Player1choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card1.ImageLocation = hand_draw();
                player = false;
                counter++;
                player1card = card;
                label2.ForeColor = Color.Black;
                label1.ForeColor = Color.Yellow;
            }
            else
                MessageBox.Show("Not Player 1 turn");
        }

        private void Card2_Click(object sender, EventArgs e)
        {
            if (player)
            {
                initalCount = 1;
                Player1choice.Image = Card2.Image;
                Player1choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card2.ImageLocation = hand_draw();
                player = false;
                counter++;
                player1card = card;
                label2.ForeColor = Color.Black;
                label1.ForeColor = Color.Yellow;
            }
            else
                MessageBox.Show("Not Player 1 turn");
        }

        private void Card3_Click(object sender, EventArgs e)
        {
            if (player)
            {
                initalCount = 2;
                Player1choice.Image = Card3.Image;
                Player1choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card3.ImageLocation = hand_draw();
                player = false;
                counter++;
                player1card = card;
                label2.ForeColor = Color.Black;
                label1.ForeColor = Color.Yellow;
            }
            else
                MessageBox.Show("Not Player 1 turn");
        }

        private void Card4_Click(object sender, EventArgs e)
        {
            if (player)
            {
                initalCount = 3;
                Player1choice.Image = Card4.Image;
                Player1choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card4.ImageLocation = hand_draw();
                player = false;
                counter++;
                player1card = card;
                label2.ForeColor = Color.Black;
                label1.ForeColor = Color.Yellow;
            }
            else
                MessageBox.Show("Not Player 1 turn");
        }

        private void Card5_Click(object sender, EventArgs e)
        {
            if (player)
            {
                initalCount = 4;
                Player1choice.Image = Card5.Image;
                Player1choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card5.ImageLocation = hand_draw();
                player = false;
                counter++;
                player1card = card;
                label2.ForeColor = Color.Black;
                label1.ForeColor = Color.Yellow;
                
            }
            else
                MessageBox.Show("Not Player 1 turn");
        }

        private void Card6_Click(object sender, EventArgs e)
        {
            if (!player)
            {
                initalCount = 5;
                Player2choice.Image = Card6.Image;
                Player2choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card6.ImageLocation = hand_draw();
                player = true;
                counter++;
                player2card = card;
                score(player1card, player2card);
                label2.ForeColor = Color.Yellow;
                label1.ForeColor = Color.Black;
            }
            else
                MessageBox.Show("Not Player 2 turn");
        }

        private void Card7_Click(object sender, EventArgs e)
        {
            if (!player)
            {
                initalCount = 6;
                Player2choice.Image = Card7.Image;
                Player2choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card7.ImageLocation = hand_draw();
                player = true;
                counter++;
                player2card = card;
                score(player1card, player2card);
                label2.ForeColor = Color.Yellow;
                label1.ForeColor = Color.Black;
            }
            else
                MessageBox.Show("Not Player 2 turn");
        }

        private void Card8_Click(object sender, EventArgs e)
        {
            if (!player)
            {
                initalCount = 7;
                Player2choice.Image = Card8.Image;
                Player2choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card8.ImageLocation = hand_draw();
                player = true;
                counter++;
                player2card = card;
                score(player1card, player2card);
                label2.ForeColor = Color.Yellow;
                label1.ForeColor = Color.Black;
            }
            else
                MessageBox.Show("Not Player 2 turn");
        }

        private void Card9_Click(object sender, EventArgs e)
        {
            if (!player)
            {
                initalCount = 8;
                Player2choice.Image = Card9.Image;
                Player2choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card9.ImageLocation = hand_draw();
                player = true;
                counter++;
                player2card = card;
                score(player1card, player2card);
                label2.ForeColor = Color.Yellow;
                label1.ForeColor = Color.Black;
            }
            else
                MessageBox.Show("Not Player 2 turn");
        }

        private void Card10_Click(object sender, EventArgs e)
        {
            if (!player)
            {
                initalCount = 9;
                Player2choice.Image = Card10.Image;
                Player2choice.SizeMode = PictureBoxSizeMode.Zoom;
                Card10.ImageLocation = hand_draw();
                player = true;
                counter++;
                player2card = card;
                score(player1card, player2card);
                label2.ForeColor = Color.Yellow;
                label1.ForeColor = Color.Black;
            }
            else
                MessageBox.Show("Not Player 2 turn");
        }

        public int catagories(int cardnum)
        {
            int catagoy = 0;
            switch (cardnum)
            {
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                    catagoy = 1;
                    break;
                case 7:
                case 8:
                case 9:
                case 10:
                case 11:
                case 12:
                    catagoy = 2;
                    break;
                case 13:
                case 14:
                case 15:
                case 16:
                case 17:
                case 18:
                    catagoy = 3;
                    break;
                case 19:
                case 20:
                case 21:
                case 22:
                case 23:
                case 24:
                    catagoy = 4;
                    break;
                case 25:
                case 26:
                case 27:
                case 28:
                case 29:
                case 30:
                    catagoy = 5;
                    break;
                case 31:
                case 32:
                case 33:
                case 34:
                case 35:
                case 36:
                    catagoy = 6;
                    break;
                case 37:
                case 38:
                case 39:
                case 40:
                case 41:
                case 42:
                    catagoy = 7;
                    break;
                case 43:
                case 44:
                case 45:
                case 46:
                case 47:
                case 48:
                    catagoy = 8;
                    break;
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                    catagoy = 9;
                    break;
                case 55:
                case 56:
                case 57:
                case 58:
                case 59:
                case 60:
                    catagoy = 10;
                    break;
                default:
                    break;
            }
            return catagoy;
        }

        public void score(int player1, int player2)
        {
            if (counter >= 2)
            {
                player1score = audience_affect(player1card, audienceValues);
                player2score = audience_affect(player2card, audienceValues);
                if (player1score > player2score)
                    score1++;
                else if (player2score > player1score)
                    score2++;
                else
                {
                    score1++;
                    score2++;
                }
                label2.Text = "Player 1: " + score1;
                label1.Text = "Player 2: " + score2;
                AudienceThingy();
                counter = 0;
                if (usedACards.Count == 40 || usedCards.Count == 60)
                {
                    if (score1 > score2)
                        MessageBox.Show("Player 1 wins!");
                    else if (score2 > score1)
                        MessageBox.Show("Player 2 wins!");
                    else
                        MessageBox.Show("Draw!");
                    ProcessStartInfo Info = new ProcessStartInfo();
                    Info.Arguments = "/C ping 127.0.0.1 -n 2 && \"" + Application.ExecutablePath + "\"";
                    Info.WindowStyle = ProcessWindowStyle.Hidden;
                    Info.CreateNoWindow = true;
                    Info.FileName = "cmd.exe";
                    Process.Start(Info);
                    Application.Exit(); 
                }
            }
        }

        public int audience_affect(int cat, int[] audienceValues)
        {
            int score = 5;
            foreach (int i in audienceValues)
            {
                switch (i)
                {
                case 1:
                    if (cat == 2)
                        score += 1;
                    else if (cat == 8)
                        score -= 2;
                    break;
                case 2:
                    if (cat == 8)
                        score += 3;
                    else if (cat == 7)
                        score -= 1;
                    break;
                case 3:
                    if (cat == 5)
                        score += 1;
                    else if (cat == 8)
                        score -= 2;
                    break;
                case 4:
                    if (cat == 4)
                        score += 1;
                    else if (cat == 9)
                        score -= 2;
                    break;
                case 5:
                    if (cat == 1)
                        score += 3;
                    else if (cat == 7)
                        score -= 2;
                    break;
                case 6:
                    if (cat == 3)
                        score += 1;
                    else if (cat == 4)
                        score -= 2;
                    break;
                case 7:
                    if (cat == 1)
                        score += 2;
                    else if (cat == 10)
                        score -= 4;
                    break;
                case 8:
                    if (cat == 7)
                        score += 1;
                    else if (cat == 1)
                        score -= 3;
                    break;
                case 9:
                    if (cat == 7)
                        score += 1;
                    else if (cat == 1)
                        score -= 3;
                    break;
                case 10:
                    if (cat == 3)
                        score += 1;
                    else if (cat == 9)
                        score -= 2;
                    break;
                case 11:
                    if (cat == 3)
                        score += 1;
                    else if (cat == 9)
                        score -= 2;
                    break;
                case 12:
                    if (cat == 5)
                        score += 2;
                    else if (cat == 10)
                        score -= 1;
                    break;
                case 13:
                    if (cat == 2)
                        score += 3;
                    else if (cat == 4)
                        score -= 1;
                    break;
                case 14:
                    if (cat == 1)
                        score += 2;
                    else if (cat == 2)
                        score -= 2;
                    break;
                case 15:
                    if (cat == 5)
                        score += 2;
                    else if (cat == 3)
                        score -= 1;
                    break;
                case 16:
                    if (cat == 10)
                        score += 1;
                    else if (cat == 4)
                        score -= 1;
                    break;
                case 17:
                    if (cat == 1)
                        score += 2;
                    else if (cat == 10)
                        score -= 1;
                    break;
                case 18:
                    if (cat == 1)
                        score += 1;
                    else if (cat == 4)
                        score -= 1;
                    break;
                case 19:
                    if (cat == 6)
                        score += 2;
                    else if (cat == 7)
                        score -= 3;
                    break;
                case 20:
                    if (cat == 8)
                        score += 4;
                    else if (cat == 10)
                        score -= 3;
                    break;
                case 21:
                    if (cat == 5)
                        score += 2;
                    else if (cat == 6)
                        score -= 3;
                    break;
                case 22:
                    if (cat == 2)
                        score += 3;
                    else if (cat == 2)
                        score -= 2;
                    break;
                case 23:
                    if (cat == 3)
                        score += 1;
                    else if (cat == 4)
                        score -= 2;
                    break;
                case 24:
                    if (cat == 3)
                        score += 3;
                    else if (cat == 1)
                        score -= 1;
                    break;
                case 25:
                    if (cat == 8)
                        score -= 3;
                    else if (cat == 10)
                        score -= 3;
                    break;
                case 26:
                    if (cat == 9)
                        score += 1;
                    else if (cat == 1)
                        score -= 2;
                    break;
                case 27:
                    if (cat == 2)
                        score += 3;
                    else if (cat == 1)
                        score -= 2;
                    break;
                case 28:
                    score = -4;
                    break;
                case 29:
                    if (cat == 9)
                        score += 1;
                    else if (cat == 4)
                        score -= 2;
                    break;
                case 30:
                    if (cat == 1)
                        score += 3;
                    else if (cat == 2)
                        score -= 3;
                    break;
                case 31:
                    if (cat == 7)
                        score += 3;
                    else if (cat == 3)
                        score -= 3;
                    break;
                case 32:
                    if (cat == 3)
                        score += 1;
                    else if (cat == 4)
                        score -= 1;
                    break;
                case 33:
                    if (cat == 7)
                        score += 2;
                    else if (cat == 2)
                        score -= 2;
                    break;
                case 34:
                    if (cat == 3)
                        score += 2;
                    else if (cat == 9)
                        score -= 3;
                    break;
                case 35:
                    if (cat == 3)
                        score += 1;
                    else if (cat == 1)
                        score -= 1;
                    break;
                case 36:
                    if (cat == 7)
                        score += 2;
                    else if (cat == 2)
                        score -= 2;
                    break;
                case 37:
                    if (cat == 7)
                        score += 1;
                    else if (cat == 4)
                        score -= 1;
                    break;
                case 38:
                    if (cat == 5)
                        score += 1;
                    else if (cat == 2)
                        score -= 2;
                    break;
                case 39:
                    if (cat == 5)
                        score += 2;
                    else if (cat == 2)
                        score -= 2;
                    break;
                case 40:
                    if (cat == 4)
                        score += 2;
                    else if (cat == 6)
                        score -= 1;
                    break;
                default:
                    break;
                }
            }
            return score;
        }
    }
}
